package com.example.hellsbells;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ListView;

import com.example.hellsbells.beans.Producto;
import com.example.hellsbells.beans.TipoProducto;

public class ActividadPedido extends ListActivity {
	
	private int idPedido;
	private String tipo;
	private TipoProducto tipoProducto;
	private ArrayList<Producto> hayPedidoPrevio;
	
    @Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadoproductos);        
        
        Bundle extras = getIntent().getExtras();        
        tipo = (String) extras.get("tipo");
        tipoProducto = (TipoProducto) extras.get("tipoProducto");
        hayPedidoPrevio = (ArrayList<Producto>) extras.get("hayPedidoPrevio");
        
        if("consulta".equals(tipo)){
        	idPedido = (int) extras.get("idPedido");
        	setListAdapter(new MiAdaptadorPedido(this, hayPedidoPrevio,
        		MainActivity.basedatos.listaProductosPedido(tipoProducto.getId(),idPedido)));
        }else{
        	setListAdapter(new MiAdaptadorPedido(this, hayPedidoPrevio, 
        			MainActivity.basedatos.listaProductos(tipoProducto.getId())));
        }
        
    }
    
    public void sumarUno(View view){
    	int position = getListView().getPositionForView((View) view.getParent());
    	View vista = getListView().getChildAt(position);
    	EditText cantidad = (EditText)vista.findViewById(R.id.cantidad);
    	if(cantidad != null ){
    		try {
				int data = Integer.parseInt(cantidad.getText().toString());				
				data = data + 1;
				cantidad.setText(String.valueOf(data));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			}
    	}
	}
    
    public void restarUno(View view){
    	int position = getListView().getPositionForView((View) view.getParent());
    	View vista = getListView().getChildAt(position);
    	EditText cantidad = (EditText)vista.findViewById(R.id.cantidad);
    	if(cantidad != null ){
    		try {
				int data = Integer.parseInt(cantidad.getText().toString());				
				data = data - 1;
				if(data<0) data = 0;
				cantidad.setText(String.valueOf(data));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			}
    	}
	}
    
    public void guardarPedido(View view){
    	boolean hayDatos = false;
    	ArrayList<TipoProducto> pedidoParcial = new ArrayList<TipoProducto>();
    	int numElementos = getListAdapter().getCount();
    	
    	
    	tipoProducto.setProductos(new ArrayList<Producto>());
    	for (int i = 0; i < numElementos; i++) {
    		Producto prod = (Producto) getListAdapter().getItem(i);
    		View vista = getListView().getChildAt(i);
    	    EditText cantidad =(EditText)vista.findViewById(R.id.cantidad);
    	    if(!cantidad.getText().toString().equals("0")){
    	    	hayDatos = true;
    	    	Producto p = new Producto(prod.getId(),prod.getNombre(), prod.getCantidadStock(),
    	    			Integer.parseInt(cantidad.getText().toString()),prod.getPrecio(),prod.getIdTipoProducto());
    	    	    	
    	    	tipoProducto.getProductos().add(p);
    	    }
		}
    	pedidoParcial.add(tipoProducto);
    	if(hayDatos){
	    	Intent intent = new Intent();
	    	intent.putExtra("pedidoParcial",pedidoParcial);
	        setResult(RESULT_OK, intent);
    	}else{
    		Intent intent = new Intent();
    		setResult(RESULT_CANCELED, intent);
    	}
        finish();
	}
    
    @Override 
    public boolean onCreateOptionsMenu(Menu menu) { 
	    if("consulta".equals(tipo)){
    		super.onCreateOptionsMenu(menu);
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menupedidotipoproducto, menu);	       
    	}
	    return true; 
     }

    
     @Override 
     public boolean onOptionsItemSelected(MenuItem item) {
    	 if("consulta".equals(tipo)){
	         switch (item.getItemId()) {
	         case R.id.nuevoTipo:
	             lanzarNuevoProductoPedido(null);
	             break;      
	         }
    	 }
	     return true;   	

     }
     
     public void lanzarNuevoProductoPedido(final View view){    
  		
  		AlertDialog.Builder builder = new AlertDialog.Builder(this);
  		builder.setTitle(getString(R.string.addtipo));
  		builder.setItems(MainActivity.basedatos.getProductoToAdd(idPedido,tipoProducto.getId()), 
  				new DialogInterface.OnClickListener() {
  		    @Override
  		    public void onClick(DialogInterface dialog, int which) {
  		    	ListView lw = ((AlertDialog)dialog).getListView();
  		    	String prod = (String) lw.getAdapter().getItem(which);
  		    	
  		    	MainActivity.basedatos.addProductoApedido(prod,idPedido,tipoProducto.getId());
  		    	finish();

  		    }
  		});
  		builder.show();
  	}
}