package com.example.hellsbells;

import java.util.ArrayList;
import java.util.Calendar;

import android.app.AlarmManager;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.os.PowerManager;
import android.support.v4.app.NotificationCompat;

public class AlertaDiaria extends BroadcastReceiver 
{    

	 private NotificationManager nm;
	 private static final int ID_NOTIFICACION_CREAR = 1;
	 NotificationCompat.Builder  mBuilder;
	
	 @Override
     public void onReceive(Context context, Intent intent) 
     {   
         PowerManager pm = (PowerManager) context.getSystemService(Context.POWER_SERVICE);
         PowerManager.WakeLock wl = pm.newWakeLock(PowerManager.PARTIAL_WAKE_LOCK, "");
         wl.acquire();
         
         SharedPreferences pref = context.getSharedPreferences("com.example.hellsbells_preferences", Context.MODE_PRIVATE);
         if(pref.getBoolean("notificacion", true)){
//        	 ThreadAlarma thread = new ThreadAlarma();
//        	 thread.setContext(context);
//        	 thread.start();
        	 lanzarNotificacion(context);
             
         }else{
        	 CancelAlarm(context);
         }

         wl.release();
     }

	 public void SetAlarm(Context context, Object newValue)
	 {
		 AlarmManager am=(AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
	     Intent i = new Intent(context, AlertaDiaria.class);
	     PendingIntent pi = PendingIntent.getBroadcast(context, 0, i, 0);
	     
	     SharedPreferences pref = context.getSharedPreferences("com.example.hellsbells_preferences", Context.MODE_PRIVATE);
	     String hora = pref.getString("horaNotificacion","22");
	     int  hour = 22;
	     if(hora!=null && !"".equals(hora) && hora.length()<3){
	    	 hour = Integer.parseInt(pref.getString("horaNotificacion","22"));
	     }
	     if(newValue!=null){
	    	 hour = Integer.parseInt((String) newValue);
	     }
	     
	     Calendar time = Calendar.getInstance();	     
	     time.setTimeInMillis(System.currentTimeMillis());
	     time.set(Calendar.HOUR_OF_DAY, hour);
	     time.set(Calendar.MINUTE, 0);
	     time.set(Calendar.SECOND, 0);
	     
	     am.setRepeating(AlarmManager.RTC_WAKEUP, time.getTimeInMillis(), (1 * 24 * 3600 * 1000), pi);
	     
	     //am.setExact(type, triggerAtMillis, operation).setInexactRepeating(AlarmManager.RTC_WAKEUP, time.getTimeInMillis(), 1000*24*60*60, pi);
	     //am.setInexactRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP, 10000, 10000, pi);
	 }
	
	 public void CancelAlarm(Context context)
	 {
	     Intent intent = new Intent(context, AlertaDiaria.class);
	     PendingIntent sender = PendingIntent.getBroadcast(context, 0, intent, 0);
	     AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
	     alarmManager.cancel(sender);
	 }
	 
	 
	public void lanzarNotificacion(Context ctx) {	 
		 
		SharedPreferences pref = ctx.getSharedPreferences("com.example.hellsbells_preferences", Context.MODE_PRIVATE);

		String minimoNotificacion = pref.getString("minimoNotificacion", "0");
		ArrayList<String> datosMinimos = (ArrayList<String>) 
				MainActivity.basedatos.getProductosMinimo(Integer.parseInt(minimoNotificacion));
		//Obtener datos
		
		if(!datosMinimos.isEmpty()){
			 nm = (NotificationManager)ctx.getSystemService(ctx.NOTIFICATION_SERVICE);
       	 
			 Intent notificationIntent = new Intent(ctx, ActividadNotificacion.class);
			 notificationIntent.putExtra("datosMinimos", datosMinimos);
			 
			 PendingIntent intencionPendiente = PendingIntent.getActivity(ctx, 0, notificationIntent, 0);		 
	       	 
	       	 NotificationCompat.Builder  mBuilder = new NotificationCompat.Builder(ctx);
	   	     
	   	     mBuilder.setContentTitle(ctx.getString(R.string.notificacionhellsbells));
	            mBuilder.setContentText(ctx.getString(R.string.stock)+minimoNotificacion+")");
	            mBuilder.setSmallIcon(R.drawable.block);
	            mBuilder.setLargeIcon(BitmapFactory.decodeResource(ctx.getResources(), R.drawable.block));
	            mBuilder.setWhen(System.currentTimeMillis());
	            mBuilder.setAutoCancel(true);
	            mBuilder.setContentIntent(intencionPendiente);
	            
	            Notification note = mBuilder.build();
	            note.defaults |= Notification.DEFAULT_VIBRATE;
	            note.defaults |= Notification.DEFAULT_SOUND;
	
	            nm.notify(ID_NOTIFICACION_CREAR, mBuilder.build());
		}
  
	}
	
	

}