package com.example.hellsbells;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.example.hellsbells.beans.Producto;
import com.example.hellsbells.beans.TipoProducto;

public class Almacen extends ListActivity {
	
	private TipoProducto tipoProducto;
	
    @Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadoproductosalmacen);
        
        Bundle extras = getIntent().getExtras();
        tipoProducto = (TipoProducto) extras.get("tipoProducto");
        
        setListAdapter(new MiAdaptadorPedidoAlmacen(this, 
        		MainActivity.basedatos.listaProductos(tipoProducto.getId())));
        
        
    }
    
    public void lanzarNuevoProducto(View view){
    	LayoutInflater li = LayoutInflater.from(this);
		View promptsView = li.inflate(R.layout.nuevo_producto, null);

		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
		alertDialogBuilder.setView(promptsView);

		final EditText nombre = (EditText) promptsView.findViewById(R.id.editTextNombre);
		final EditText cantidad = (EditText) promptsView.findViewById(R.id.editTextCantidad);
		final EditText precio = (EditText) promptsView.findViewById(R.id.editTextPrecio);

		alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	boolean ok = true;
			    	if(nombre.getText().toString().equals("")){
			    		Toast.makeText(Almacen.this, getString(R.string.nombreobligatorio), Toast.LENGTH_LONG).show();
			    		ok = false;
			    	}
			    	if(cantidad.getText().toString().equals("")){
			    		Toast.makeText(Almacen.this, getString(R.string.cantidadobligatoria), Toast.LENGTH_LONG).show();
			    		ok = false;
			    	}
			    	if(precio.getText().toString().equals("")){
			    		Toast.makeText(Almacen.this, getString(R.string.precioobligatorio), Toast.LENGTH_LONG).show();
			    		ok = false;
			    	}
			    	String prec = precio.getText().toString().trim().replace(",", ".");
			    	
			    	if (ok){
				    	try {
							MainActivity.basedatos.guardarProducto(new Producto (0,
									nombre.getText().toString(), Integer.parseInt(cantidad.getText().toString()),0,
									Double.parseDouble(prec), tipoProducto.getId()));
						} catch (NumberFormatException e) {
							Toast.makeText(Almacen.this, getString(R.string.datoserroneos), Toast.LENGTH_LONG).show();
						}
			    	}
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		})
		.setNegativeButton("Cancel",new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		});

		AlertDialog alertDialog = alertDialogBuilder.create();
		alertDialog.show();
	}
    
    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menuproducto, menu);
        return true; /** true -> el men ya est visible */

     }
    
    @Override 
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case R.id.nuevoProducto:
            lanzarNuevoProducto(null);
            break;         
//        case R.id.borrarProducto:
//            //lanzarBorrarProducto(null);
//            break;
//    	 case R.id.menu_buscar:
//    		 //lanzarBuscar(null);
//    		 break;
        }
        return true; /** true -> consumimos el item, no se propaga*/

    }
    
}