package com.example.hellsbells;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.example.hellsbells.beans.Pedido;

public class ConsultaPedido extends Activity {
	
	@Override 
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.consulta_pedido);
    }
    
	public void buscarPedido(View v){
				
		DateDisplayPicker fecha = (DateDisplayPicker) findViewById(R.id.editTextFechaPedido);
		EditText nombrePedido = (EditText) findViewById(R.id.editNombrePedidoBuscar);
		
		
		if(nombrePedido.getText().toString().equals("") && fecha.getText().toString().equals("")){
			Toast.makeText(this, getString(R.string.obligatorionombrefecha), Toast.LENGTH_SHORT).show();
		}else{
		
		List<Pedido> pedidos = MainActivity.basedatos.listaPedidos(nombrePedido.getText().toString(),fecha.getText().toString());
			if(pedidos.isEmpty()){
				Toast.makeText(this, getString(R.string.noresultados), Toast.LENGTH_SHORT).show();
			}else if(pedidos.size()>1){
				Toast.makeText(this, getString(R.string.muchosresultados), Toast.LENGTH_SHORT).show();
			}else{
				Pedido pedido = pedidos.get(0);
				Intent i = new Intent(this, ListadoTipoProductos.class);
			    i.putExtra("opcion", "consulta");
			    i.putExtra("contenido", pedido);
			    startActivity(i);
			}
		}
	}
	
	public void verPedidos(View v){
		
			ArrayList<Pedido> pedidos = (ArrayList<Pedido>) MainActivity.basedatos.listaPedidos("","");
			if(pedidos.isEmpty()){
				Toast.makeText(this, getString(R.string.noresultados), Toast.LENGTH_SHORT).show();
			}else{
				Intent i = new Intent(this, ListadoPedidos.class);			
			    i.putExtra("contenido", pedidos);
			    startActivity(i);
			}
	}
	
	public void reset(View v){		
		DateDisplayPicker fecha = (DateDisplayPicker) findViewById(R.id.editTextFechaPedido);
		EditText nombrePedido = (EditText) findViewById(R.id.editNombrePedidoBuscar);
		
		fecha.setText("");
		nombrePedido.setText("");
	}
	
	 public void inicio(View view){
	    	Intent i = new Intent(this, MainActivity.class);					   
		    startActivity(i);
	    }
   
}