package com.example.hellsbells;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ListView;
import android.widget.Toast;

import com.example.hellsbells.beans.Pedido;
import com.example.hellsbells.beans.TipoProducto;
import com.example.hellsbells.util.Util;

public class ListadoPedidos extends ListActivity {
	
	
	private List<TipoProducto> pedido = new ArrayList<TipoProducto>(); 

    @Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        List<Pedido> pedidosConsulta = (ArrayList<Pedido>) getIntent().getSerializableExtra("contenido");
        setContentView(R.layout.listadotipoproductos);
    	setListAdapter(new MiAdaptadorListaPedidos(this, pedidosConsulta));
    	
    	ListView lv = getListView();
    	lv.setOnItemLongClickListener (new OnItemLongClickListener() {    		
			@Override
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				Pedido pedido = (Pedido) getListAdapter().getItem(position);
				eliminarPedido(view, parent.getContext(), pedido.getIdPedido());
				return true;
			}
    	});
    }
        
    
	protected void onActivityResult (int requestCode, int resultCode, Intent data){
    	if (requestCode==1111 && resultCode==RESULT_OK) {
    		List<TipoProducto> res = (List<TipoProducto>) data.getExtras().get("pedidoParcial");
    		pedido=res;    		
    	}
    }
	

    @Override 
    protected void onListItemClick(ListView listView, View view, int position, long id) {
    	super.onListItemClick(listView, view, position, id);
    	Pedido pedido = (Pedido) getListAdapter().getItem(position);
    	Intent i = new Intent(this, ListadoTipoProductos.class);
	    i.putExtra("opcion", "consulta");
	    i.putExtra("contenido", pedido);
	    startActivity(i);
    }
    
    public void eliminarPedido(View view, final Context ctx, final int idPedido){
    	LayoutInflater li = LayoutInflater.from(ctx);
		View promptsView = li.inflate(R.layout.delete_producto, null);

		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(ctx);
		alertDialogBuilder.setView(promptsView);

		alertDialogBuilder.setPositiveButton(getString(R.string.eliminar),new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	MainActivity.basedatos.deletePedido(idPedido);
			    	Toast.makeText(ctx, getString(R.string.pedidoeliminado), Toast.LENGTH_SHORT).show();
			    	((Activity)ctx).finish();
			    }
		})
		.setNeutralButton(getString(R.string.vista),new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	String[] data = Util.generateEmail(MainActivity.basedatos.getPedido(idPedido), getString(R.string.contenidopedido),
			    			getString(R.string.preciounitario),getString(R.string.preciototalpedido));
			    	Intent i = new Intent(ListadoPedidos.this, Previa.class);
				    i.putExtra("previa", data[0]);
				    startActivity(i);
			    	//((Activity)ctx).finish();
			    }
		})
		.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	//((Activity)ctx).finish();
			    	dialog.dismiss();
			    }
		});

		AlertDialog alertDialog = alertDialogBuilder.create();
		alertDialog.show();
	}
    
  
}