package com.example.hellsbells;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutionException;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.app.Notification;
import android.app.NotificationManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.NotificationCompat;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.hellsbells.beans.Pedido;
import com.example.hellsbells.beans.Producto;
import com.example.hellsbells.beans.TipoProducto;
import com.example.hellsbells.util.Util;

public class ListadoTipoProductos extends ListActivity {
	
	private SharedPreferences pref;
	private int idPedido = -1;
	private String opcion;
	private List<TipoProducto> pedido = new ArrayList<TipoProducto>(); 
	private static final int ID_NOTIFICACION_PRECIO = 2;
	
    @Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        Bundle extras = getIntent().getExtras();
        opcion = extras.getString("opcion");
        
        pref = this.getSharedPreferences("com.example.hellsbells_preferences", Context.MODE_PRIVATE);
        
        if("almacen".equals(opcion)){
        	setContentView(R.layout.listadotipoproductos);
    	}
        else{
    		setContentView(R.layout.listadotipoproductos_pedido);    		
    	}
        
        if("consulta".equals(opcion)){
        	Pedido pedidoConsulta = (Pedido) getIntent().getSerializableExtra("contenido");
        	pedido=pedidoConsulta.getContenidoPedido();
        	
        	EditText nombrePedido = (EditText) findViewById(R.id.editTextNombrePedido);        	
        	nombrePedido.setText(pedidoConsulta.getNombrePedido());
        	
        	EditText obsPedido = (EditText) findViewById(R.id.editTextObservacionesPedido);        	
        	obsPedido.setText(pedidoConsulta.getObservaciones());
        	
        	idPedido = pedidoConsulta.getIdPedido();
        	setListAdapter(new MiAdaptador(this, MainActivity.basedatos.listaTipoProductosPedido(idPedido)));
        	
        	if(pedidoConsulta.getEmail()==1){
        		TextView titulo = (TextView) findViewById(R.id.textViewNombrePedido);
        		titulo.setText(getString(R.string.nombrePedido)+ " [EMAIL ENVIADO]");
        	}
        	
        	
           
    	}else{
    		setListAdapter(new MiAdaptador(this, MainActivity.basedatos.listaTipoProductos()));
    	}
                
        ListView lv = getListView();
        lv.setOnItemLongClickListener(new OnItemLongClickListener() {
           @Override
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				TipoProducto prod = (TipoProducto) getListAdapter().getItem(position);
				lanzarBorrarTipo(view, parent.getContext(), prod.getId());
				return true;
			}
        });

    }
        
    
	protected void onActivityResult (int requestCode, int resultCode, Intent data){
		if (requestCode==1111 && resultCode==RESULT_OK) {    	
    		List<TipoProducto> res = (List<TipoProducto>) data.getExtras().get("pedidoParcial");
    		List<TipoProducto> tpToremove = new ArrayList<TipoProducto>(); 
    		for (TipoProducto tipoProducto : pedido) {
				if(res.get(0).getNombre().equals(tipoProducto.getNombre())){
					tpToremove.add(tipoProducto);					
				}
			}
    		for (TipoProducto tipoP : tpToremove) {
    			pedido.remove(tipoP);
			}
    		pedido.addAll(res);    		
    	}
    }
	

    @Override 
    protected void onListItemClick(ListView listView, View view, int position, long id) {
    	super.onListItemClick(listView, view, position, id);
    	TipoProducto tp = (TipoProducto) getListAdapter().getItem(position);
    	
    	//Consulta almacn
    	if("almacen".equals(opcion)){
    		Intent i = new Intent(this, Almacen.class);
    		i.putExtra("tipoProducto", tp);
    		i.putExtra("tipo", "almacen");
    		i.putExtra("idPedido", idPedido);
    		startActivity(i);
    	}else if("consulta".equals(opcion)){
    		Intent i = new Intent(this, ActividadPedido.class);
    		i.putExtra("tipoProducto", tp);
    		i.putExtra("tipo", "consulta");
    		i.putExtra("idPedido", idPedido);
    		for (TipoProducto tprod : pedido) {
				if(tprod.getId().equals(tp.getId())){
					i.putExtra("hayPedidoPrevio", (ArrayList<Producto>)tprod.getProductos());
					break;
				}
			}
    		startActivityForResult(i, 1111);    		
    	//Nuevo pedido
    	}else{
    		Intent i = new Intent(this, ActividadPedido.class);
    		i.putExtra("tipoProducto", tp);
    		i.putExtra("tipo", "pedido");    		
    		for (TipoProducto tprod : pedido) {
				if(tprod.getId().equals(tp.getId())){
					i.putExtra("hayPedidoPrevio", (ArrayList<Producto>)tprod.getProductos());
					break;
				}
			}
    		startActivityForResult(i, 1111);
    	}
    	
    	
    	
    }
    
    
    public void guardarPedidoTotal(View view){
    			
    	EditText nombrePedido = (EditText) findViewById(R.id.editTextNombrePedido);
    	EditText observaciones = (EditText) findViewById(R.id.editTextObservacionesPedido);
    	
    	
    	if(nombrePedido==null || nombrePedido.getText().toString().equals("")){
    		Toast.makeText(this, getString(R.string.errornombrepedido) ,Toast.LENGTH_LONG).show();
    	}else if(pedido.isEmpty()){
    		Toast.makeText(this, getString(R.string.errornopedido),Toast.LENGTH_LONG).show();
    	}else{
    		ArrayList<String> passing = new ArrayList<String>();
    		passing.add(nombrePedido.getText().toString());
    		passing.add(observaciones.getText().toString());
    		
    		try {
				new guardarPedidoTotalAsync().execute(passing).get();
			} catch (InterruptedException e) {
				Toast.makeText(ListadoTipoProductos.this, getString(R.string.errorpedido), Toast.LENGTH_LONG).show();
			} catch (ExecutionException e) {
				Toast.makeText(ListadoTipoProductos.this, getString(R.string.errorpedido), Toast.LENGTH_LONG).show();
			}   		
   
    	}
	}
    
    private class guardarPedidoTotalAsync extends AsyncTask<ArrayList<String>, Integer, String> {

        @Override
        protected String doInBackground(ArrayList<String>... params) {

        	String patron = "dd/MM/yyyy";
            SimpleDateFormat formato = new SimpleDateFormat(patron);            
            
            ArrayList<String> passed = params[0];
            
    		Pedido p = new Pedido(0,passed.get(0), formato.format(new Date()), 
    				pedido, 0, passed.get(1));
    		String result = MainActivity.basedatos.guardarPedido(p,opcion);
    		return result;
        }

        @Override
        protected void onPostExecute(String result) {                     
        	if(result.equals("DUPLICADO")){
    			Toast.makeText(ListadoTipoProductos.this, getString(R.string.pedidoduplicado), Toast.LENGTH_LONG).show();
    		}else if(result.equals("ERROR")){
    			Toast.makeText(ListadoTipoProductos.this, getString(R.string.errorpedido), Toast.LENGTH_LONG).show();
    		}else if(result.equals("NOTFOUND")){
    			Toast.makeText(ListadoTipoProductos.this, getString(R.string.pedidonoencontrado), Toast.LENGTH_LONG).show();
    		}else{
    			idPedido = Integer.parseInt(result);
    			Toast.makeText(ListadoTipoProductos.this, getString(R.string.pedidook), Toast.LENGTH_LONG).show();
    			Intent i = new Intent(ListadoTipoProductos.this,MainActivity.class);
    			startActivity(i);
    			
    		}
        }
    }
    
    public void vistaPrevia(View view){
    	if(idPedido < 0 ){
			Toast.makeText(this, getString(R.string.previaerror), Toast.LENGTH_SHORT).show();
		}else{
		    String[] data = Util.generateEmail(MainActivity.basedatos.getPedido(idPedido), getString(R.string.contenidopedido),
					getString(R.string.preciounitario),getString(R.string.preciototalpedido));
			Intent i = new Intent(this, Previa.class);
		    i.putExtra("previa", data[0]);
		    startActivity(i);
		}
    }
    
    public void enviarMail(View view){
    	
    	EditText nombrePedido = (EditText) findViewById(R.id.editTextNombrePedido);
    	
    	if(idPedido < 0 ){
			Toast.makeText(this, getString(R.string.emailerror), Toast.LENGTH_SHORT).show();
		}else{
			
			Pedido pedido = MainActivity.basedatos.getPedido(idPedido);
			
	    	Intent itSend = new Intent(Intent.ACTION_SEND, Uri.parse("mailto:"));
	    	itSend.setType("text/plain");
	    	//itSend.setType("text/html");
	    	itSend.putExtra(Intent.EXTRA_EMAIL, pref.getString("mail", "fjgmontesinos@gmail.com").split(";"));
	    	itSend.putExtra(Intent.EXTRA_SUBJECT, "Envio pedido");
	    	
	    	String[] mail = Util.generateTxtEmail(pedido,getString(R.string.contenidopedido),
	    			getString(R.string.preciounitario),getString(R.string.preciototalpedido));
			
			String prefPrecio = pref.getString("maximoImporte", "0");
			double total = Double.parseDouble(mail[1]);
			if(total > Double.parseDouble(prefPrecio)){
				 NotificationManager nm = (NotificationManager)this.getSystemService(this.NOTIFICATION_SERVICE);
		       	 NotificationCompat.Builder  mBuilder = new NotificationCompat.Builder(this);
		   	     
		   	     mBuilder.setContentTitle(getString(R.string.notificacionhellsbells));
		            mBuilder.setContentText(getString(R.string.superaprecio)+prefPrecio+" ");
		            mBuilder.setSmallIcon(R.drawable.block);
		            mBuilder.setLargeIcon(BitmapFactory.decodeResource(this.getResources(), R.drawable.block));
		            mBuilder.setWhen(System.currentTimeMillis());
		            mBuilder.setAutoCancel(true);
		            
		            Notification note = mBuilder.build();
		            note.defaults |= Notification.DEFAULT_VIBRATE;
		            note.defaults |= Notification.DEFAULT_SOUND;
		
		            nm.notify(ID_NOTIFICACION_PRECIO, mBuilder.build());
			}			
			itSend.setType("message/rfc822");
			
			itSend.putExtra(Intent.EXTRA_TEXT, mail[0]);
	    	
			MainActivity.basedatos.setEmail(true,idPedido);
			
			Toast.makeText(ListadoTipoProductos.this, getString(R.string.mailok), Toast.LENGTH_LONG).show();
	    	startActivity(Intent.createChooser(itSend, "Email:"));
		}
    	
	}
    
    public void eliminarPedido(View view){
    	if(idPedido < 0 ){
			Toast.makeText(this, getString(R.string.erroreliminarpedido), Toast.LENGTH_SHORT).show();
		}else{   	  	  
			
			LayoutInflater li = LayoutInflater.from(this);
			View promptsView = li.inflate(R.layout.delete_producto, null);

			AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
			alertDialogBuilder.setView(promptsView);

			alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	MainActivity.basedatos.deletePedido(idPedido);
				    	Intent i = new Intent(ListadoTipoProductos.this, ConsultaPedido.class);					   
					    startActivity(i);
				    }
			})
			.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	//finish();
				    	dialog.dismiss();
				    }
			});

			AlertDialog alertDialog = alertDialogBuilder.create();
			alertDialog.show();
		}
	}
    
    public void copiarPedido(View view){
    	if(idPedido < 0 ){
			Toast.makeText(this, getString(R.string.errorcopiarpedido), Toast.LENGTH_SHORT).show();
		}else{   	  	  
			
			LayoutInflater li = LayoutInflater.from(this);
			View promptsView = li.inflate(R.layout.copia_pedido, null);

			AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
			alertDialogBuilder.setView(promptsView);

			final EditText nombre = (EditText) promptsView.findViewById(R.id.editTextNombre);
			final EditText observaciones = (EditText) promptsView.findViewById(R.id.editTextDescripcion);
			
			alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	if(nombre.getText().toString().equals("")){
				    		Toast.makeText(ListadoTipoProductos.this,getString(R.string.nombreobligatorio), Toast.LENGTH_LONG).show();
				    	}else{
				    		String ins = MainActivity.basedatos.copiarPedido(idPedido,nombre.getText().toString(),observaciones.getText().toString());
				    		if("DUPLICADO".equals(ins)){
					    		Toast.makeText(ListadoTipoProductos.this, getString(R.string.pedidoduplicado), Toast.LENGTH_LONG).show();
					    	}
				    	}
//				    	Intent intent = getIntent();
//				        finish();
//				        startActivity(intent);
				        Intent i = new Intent(ListadoTipoProductos.this,MainActivity.class);
		    			startActivity(i);
				    }
			})
			.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	Intent intent = getIntent();
				        finish();
				        startActivity(intent);
				    }
			});

			AlertDialog alertDialog = alertDialogBuilder.create();
			alertDialog.show();
		}
    }
    
   
    
    public void llegadaPedido(View view){
    	if(idPedido < 0 ){
			Toast.makeText(this, getString(R.string.erroractualizarpedido), Toast.LENGTH_SHORT).show();
		}else{   	  	  
			
			LayoutInflater li = LayoutInflater.from(this);
			View promptsView = li.inflate(R.layout.actualizar_pedido, null);

			final Pedido p = MainActivity.basedatos.getPedido(idPedido);
			String message = getString(R.string.confirmactualizar);
			if(p.getActualizar()==1){
				message = getString(R.string.confirmactualizar2);
			}
			
			TextView mensaje = (TextView) promptsView.findViewById(R.id.textViewNombrePed);
			mensaje.setText(message);			
			
			AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
			alertDialogBuilder.setView(promptsView);

			alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	MainActivity.basedatos.updateProductosPedido(idPedido,p.getContenidoPedido());
				    	Intent i = new Intent(ListadoTipoProductos.this, ConsultaPedido.class);					   
					    startActivity(i);
				    }
			})
			.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
				    public void onClick(DialogInterface dialog,int id) {
				    	dialog.dismiss();
				    }
			});

			AlertDialog alertDialog = alertDialogBuilder.create();
			alertDialog.show();
		}
	}
    
    
    
    
    public void lanzarNuevoTipo(View view){
    	LayoutInflater li = LayoutInflater.from(this);
		View promptsView = li.inflate(R.layout.nuevo_tipo, null);

		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
		alertDialogBuilder.setView(promptsView);

		final EditText tipoInput = (EditText) promptsView.findViewById(R.id.editTextNombre);
		final EditText descInput = (EditText) promptsView.findViewById(R.id.editTextDescripcion);
		
		alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	if(tipoInput.getText().toString().equals("")){
			    		Toast.makeText(ListadoTipoProductos.this,getString(R.string.nombreobligatorio), Toast.LENGTH_LONG).show();
			    	}else{
			    		String ins = MainActivity.basedatos.guardarTipoProducto(new TipoProducto
			    			(0, tipoInput.getText().toString(), descInput.getText().toString(), null));
			    		if("DUPLICADO".equals(ins)){
				    		Toast.makeText(ListadoTipoProductos.this, getString(R.string.tipoduplicado), Toast.LENGTH_LONG).show();
				    	}
			    	}
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		})
		.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		});

		AlertDialog alertDialog = alertDialogBuilder.create();
		alertDialog.show();
	}
    
    
    public void lanzarBorrarTipo(View view, final Context ctx, final int idTipoProducto){
		
		LayoutInflater li = LayoutInflater.from(ctx);
		View promptsView = li.inflate(R.layout.delete_producto, null);

		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(ctx);
		alertDialogBuilder.setView(promptsView);

		alertDialogBuilder.setCancelable(false).setPositiveButton("OK",new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	MainActivity.basedatos.eliminarTipoProducto(idTipoProducto);
			    	Toast.makeText(ctx, getString(R.string.tipoeliminado), Toast.LENGTH_SHORT).show();
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		})
		.setNegativeButton(getString(R.string.cancelar),new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog,int id) {
			    	Intent intent = getIntent();
			        finish();
			        startActivity(intent);
			    }
		});

		AlertDialog alertDialog = alertDialogBuilder.create();
		alertDialog.show();
	}
    
    
    
    
    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
    	if("almacen".equals(opcion)){
	        super.onCreateOptionsMenu(menu);
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menutipoproducto, menu);
	        return true; /** true -> el men ya est visible */
    	}else{
    		super.onCreateOptionsMenu(menu);
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menupedidotipoproducto, menu);
	        return true; 
    	}

     }

    
     @Override 
     public boolean onOptionsItemSelected(MenuItem item) {
    	 if("almacen".equals(opcion)){
	         switch (item.getItemId()) {
	         case R.id.nuevoTipo:
	             lanzarNuevoTipo(null);
	             break;         
//	         case R.id.borrarTipo:
//	             lanzarBorrarTipo(null);
//	             break;
//	     	 case R.id.menu_buscar:
//	     		 //lanzarBuscar(null);
//	     		 break;
	         }
	         return true; /** true -> consumimos el item, no se propaga*/
    	 }else{
    		 switch (item.getItemId()) {
	         case R.id.nuevoTipo:
	             lanzarNuevoTipoParaPedido(null);
	             break;
    		 }
	         return true; 
	         
    	 }

     }
     
     
     public void lanzarNuevoTipoParaPedido(View view){    
 		
 		AlertDialog.Builder builder = new AlertDialog.Builder(this);
 		builder.setTitle(getString(R.string.addtipo));
 		builder.setItems(MainActivity.basedatos.getTipoProductoToAdd(idPedido), new DialogInterface.OnClickListener() {
 		    @Override
 		    public void onClick(DialogInterface dialog, int which) {
 		    	ListView lw = ((AlertDialog)dialog).getListView();
 		    	String tp = (String) lw.getAdapter().getItem(which);
 		    	
 		    	MainActivity.basedatos.addTipoProductoApedido(tp,idPedido);

 		    	Intent i = getIntent();
 			    startActivity(i);
		        finish();		        
 		    }
 		});
 		builder.show();
 		
 		
 	}

}