package com.example.hellsbells;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.gesture.Gesture;
import android.gesture.GestureLibraries;
import android.gesture.GestureLibrary;
import android.gesture.GestureOverlayView;
import android.gesture.GestureOverlayView.OnGesturePerformedListener;
import android.gesture.Prediction;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.animation.AnimationUtils;
import android.widget.Button;

import com.example.hellsbells.db.AlmacenProductosDb;
import com.example.hellsbells.services.ServicioNotificacion;
import com.example.hellsbells.db.AlmacenDb;


public class MainActivity extends Activity implements OnGesturePerformedListener {
	
	public static AlmacenDb basedatos;
	
	private GestureLibrary libreria;
	
	SharedPreferences pref;
	
	SoundPool soundPool;
    int idClick;
        
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		basedatos = new AlmacenProductosDb(this);
		//basedatos.clean();
		
		((Button) findViewById(R.id.button1)).setAnimation(AnimationUtils.loadAnimation(this,R.anim.aparecer));
		((Button) findViewById(R.id.button2)).setAnimation(AnimationUtils.loadAnimation(this,R.anim.aparecer2));
		((Button) findViewById(R.id.button3)).setAnimation(AnimationUtils.loadAnimation(this,R.anim.aparecer3));
		((Button) findViewById(R.id.button4)).setAnimation(AnimationUtils.loadAnimation(this,R.anim.aparecer4));
		((Button) findViewById(R.id.button5)).setAnimation(AnimationUtils.loadAnimation(this,R.anim.aparecer5));
		
		soundPool = new SoundPool( 5, AudioManager.STREAM_MUSIC , 0);
		idClick = soundPool.load(this, R.raw.audio, 0);
		
		libreria= GestureLibraries.fromRawResource(this,R.raw.gestures);
		if(!libreria.load()) {
			 finish();
		}
		GestureOverlayView gesturesView = (GestureOverlayView) findViewById(R.id.gestures);
		gesturesView.addOnGesturePerformedListener(this);
		
		pref = this.getSharedPreferences("com.example.hellsbells_preferences", Context.MODE_PRIVATE);
						
		startService(new Intent(MainActivity.this,ServicioNotificacion.class));
		
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.
                Builder().permitNetwork().build());
		
	
	}
	
		
	public void lanzarAlmacen(View view){
	      Intent i = new Intent(this, ListadoTipoProductos.class);
	      i.putExtra("opcion", "almacen");
	      if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	      }
	      startActivity(i);
	}
	
	public void lanzarNuevoPedido(View view){
	      Intent i = new Intent(this, ListadoTipoProductos.class);
	      i.putExtra("opcion", "pedido");
	      if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	      }
	      startActivity(i);
	}
	
	public void lanzarConsulta(View view){
	      Intent i = new Intent(this, ConsultaPedido.class);
	      if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	      }
	      startActivity(i);
	}
	
	public void lanzarAcercaDe(View view){
	      Intent i = new Intent(this, AcercaDe.class);	     
	      startActivity(i);
	}
	
	public void lanzarVideo(View view){
	      Intent i = new Intent(this, Video.class);
	      startActivity(i);
	}
	
	public void lanzarConfiguracion(View view){
    	Intent i = new Intent(this, Configuracion.class);
    	if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	    }
        startActivity(i);
    }
	
	public void lanzarAlta(View view){
    	Intent i = new Intent(this, AltaProducto.class);
    	if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	    }
        startActivity(i);
    }
	
	public void lanzarSalir(View view){
		if(pref.getBoolean("sonido", true)){
	    	  soundPool.play(idClick, 1, 1, 0, 0, 1);
	    }
		finish();
	}
	
	@Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu, menu);
        return true; /** true -> el men ya est visible */

     }

     @Override 
     public boolean onOptionsItemSelected(MenuItem item) {
         switch (item.getItemId()) {
	         case R.id.acercaDe:
	                lanzarAcercaDe(null);
	                break;         
		     case R.id.menu_video:
		         	lanzarVideo(null);
		         	break;
	     }
         return true; /** true -> consumimos el item, no se propaga*/

     }

	@Override
	public void onGesturePerformed(GestureOverlayView overlay, Gesture gesture) {
		
		ArrayList<Prediction> predictions=libreria.recognize(gesture);
		if(predictions.size()>0){
	          String comando = predictions.get(0).name;

	          if(comando.equals("GestureUno")){
	        	  	lanzarAlmacen(null);
	          } else if(comando.equals("GestureDos")){
	        	    lanzarConsulta(null);
	          } else if(comando.equals("GestureTres")){
	        	    lanzarNuevoPedido(null);
	          } else if(comando.equals("GestureCuatro")){
	        	  lanzarAlta(null);
	          } else if(comando.equals("GestureCinco")){
	        	  lanzarConfiguracion(null);
	          } else if(comando.equals("GestureSeis")){
	        	  	lanzarSalir(null);
	          }

		 }
		
	}
	
	
	
	
	
	public void doReadJson(View view) {
		
		  StringBuilder builder = new StringBuilder();
		  HttpClient client = new DefaultHttpClient();
		  HttpGet httpGet = new HttpGet("http://10.0.2.2:8080/pagina5");
		  //HttpGet httpGet = new HttpGet("http://127.0.0.1:8080/pagina5");
		  String line = "";
		  try {
		    HttpResponse response = client.execute(httpGet);
		    StatusLine statusLine = response.getStatusLine();
		    int statusCode = statusLine.getStatusCode();
		    if (statusCode == 200) {		     
		      HttpEntity entity = response.getEntity();
		      InputStream content = entity.getContent();
		      BufferedReader reader = new BufferedReader(
		        new InputStreamReader(content));
		      while ((line = reader.readLine()) != null) {
		        builder.append(line);
		      }
		      tratamientoJson(builder.toString());
		    } else {
		      //this.salida.setText("Error en la conexin");
		    }
		  } catch (JSONException e) {
		     e.printStackTrace();
		  } catch (ClientProtocolException e) {
		     e.printStackTrace();
		  } catch (IOException e) {
		     e.printStackTrace();
		  }
		}
	
	
		private void tratamientoJson(String string) throws JSONException {
		   JSONArray jsonArray = new JSONArray(string);
		   for (int i = 0; i < jsonArray.length(); i++) {
		     JSONObject jsonObject = jsonArray.getJSONObject(i);
//		     this.salida.append("\n name=" + jsonObject.getString("name")
//		       + " version=" + jsonObject.getString("version")
//		       + " private=" + jsonObject.getBoolean("private") );
		   }
		}
	
}
