package com.example.hellsbells;

import java.util.List;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.example.hellsbells.beans.TipoProducto;

public class MiAdaptador extends BaseAdapter {

    private final Activity actividad;
    private final List<TipoProducto> lista;



    public MiAdaptador(Activity actividad, List<TipoProducto> lista) {
          super();
          this.actividad = actividad;
          this.lista = lista;

    }

    public View getView(int position, View convertView, ViewGroup parent) {

          LayoutInflater inflater = actividad.getLayoutInflater();

          View view = inflater.inflate(R.layout.elemento_lista, null, true); 

          TextView textView =(TextView)view.findViewById(R.id.titulo);
          textView.setText(lista.get(position).getNombre());
          
          TextView textViewSub =(TextView)view.findViewById(R.id.subtitulo);
          textViewSub.setText(lista.get(position).getDescripcion());
 

          return view;

    }

    public int getCount() {
          return lista.size();
    }

    public Object getItem(int arg0) {
          return lista.get(arg0);
    }


    public long getItemId(int position) {
          return position;
    }

}