package com.example.hellsbells;

import java.util.List;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.example.hellsbells.beans.Pedido;

public class MiAdaptadorListaPedidos extends BaseAdapter {

    private final Activity actividad;
    private final List<Pedido> lista;



    public MiAdaptadorListaPedidos(Activity actividad, List<Pedido> lista) {
          super();
          this.actividad = actividad;
          this.lista = lista;

    }

    public View getView(int position, View convertView, final ViewGroup parent) {

          LayoutInflater inflater = actividad.getLayoutInflater();
          
          View view = inflater.inflate(R.layout.elemento_lista_pedido_general, null, true); 

          int email = lista.get(position).getEmail();
          
          TextView textView =(TextView)view.findViewById(R.id.titulo);
          
          String enviado = "";
          if(email == 1)
        	  enviado = " [EMAIL ENVIADO]";
          
          String precio = String.format("%.2f", lista.get(position).getPrecioTotal())+" ";
          textView.setText(lista.get(position).getNombrePedido()+enviado);
          
          TextView textViewSub =(TextView)view.findViewById(R.id.subtitulo);          
          textViewSub.setText(lista.get(position).getFechaPedido()+" - Precio : "+precio);
          textView.setText(lista.get(position).getNombrePedido()+enviado);
                    
          return view;

    }
  

    public int getCount() {
          return lista.size();
    }

    public Object getItem(int arg0) {
          return lista.get(arg0);
    }


    public long getItemId(int position) {
          return position;
    }

}