package com.example.hellsbells;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.TextView;

import com.example.hellsbells.beans.Producto;

public class MiAdaptadorPedido extends BaseAdapter {

    private final Activity actividad;
    private final List<Producto> lista;
    private final ArrayList<Producto> hayPedidoPrevio;


    public MiAdaptadorPedido(Activity actividad, ArrayList<Producto> hayPedidoPrevio, List<Producto> lista) {
          super();
          this.actividad = actividad;
          this.lista = lista;
          this.hayPedidoPrevio = hayPedidoPrevio;

    }

    public View getView(int position, View convertView, ViewGroup parent) {

          LayoutInflater inflater = actividad.getLayoutInflater();

          View view = inflater.inflate(R.layout.elemento_lista_pedido, null, true); 

          TextView textView =(TextView)view.findViewById(R.id.textPedido);
          //textView.setText(lista.get(position).getNombre()+"("+lista.get(position).getCantidadStock()+")");
          //String name =  padRight(lista.get(position).getNombre(), 20) + "-";
          textView.setText(lista.get(position).getNombre());
          
          EditText textViewSub =(EditText)view.findViewById(R.id.cantidad);
          if(hayPedidoPrevio==null){        	  
        	  textViewSub.setText("0");
          }else{
        	  boolean coincide = false;
        	  for (Producto data : hayPedidoPrevio) {        		 
        		  if(data.getId()==lista.get(position).getId()){
        			  textViewSub.setText(data.getCantidad().toString());
        			  coincide = true;
        		  }
			  }
        	  if(!coincide)
        		  textViewSub.setText("0");        	   
          }

          return view;

    }
    
    public static String padRight(String s, int n) {
	     return String.format("%1$-" + n + "s", s);  
	}

    public int getCount() {
          return lista.size();
    }

    public Object getItem(int arg0) {
          return lista.get(arg0);
    }


    public long getItemId(int position) {
          return position;
    }

}