package com.example.hellsbells.db;

import java.util.List;

import com.example.hellsbells.beans.Pedido;
import com.example.hellsbells.beans.Producto;
import com.example.hellsbells.beans.TipoProducto;


public interface AlmacenDb {
	
	 public String guardarTipoProducto(TipoProducto tipoProducto);
	 public void eliminarTipoProducto(int idTipoProducto);
     public List<TipoProducto> listaTipoProductos();
     
     public void guardarProducto(Producto producto);
     public List<Producto> listaProductos(int tipoProducto);
     
     public String guardarPedido(Pedido pedido, String opcion);
     public List<Pedido> listaPedidos(String nombrePedido, String fechaPedido);
 	 
 	 public List<TipoProducto> listaTipoProductosPedido(int idPedido);
	 public List<String> getProductosMinimo(int minimoNotificacion);
	 public List<Producto> listaProductosPedido(int tipoProducto, int pedido);
	 public void clean();
	 public void deleteProducto(int idProducto);
	 public void setEmail(boolean b,int idPedido);
	 public Pedido getPedido(int idPedido);
	 public String[] getTipoProductoToAdd(int idPedido);
	 
	 public void addTipoProductoApedido(String tp, int idPedido);
	 public void deletePedido(int idPedido);
	 public void updateProducto(String nombre, String cantidad, String precio, int id);
	 public void updateProductosPedido(int idPedido, List<TipoProducto> contenido);
     
	 public String[] getProductoToAdd(int idPedido, int tipoProducto);
	 public void addProductoApedido(String tp, int idPedido, int tipoProducto);
	 public String copiarPedido(int idPedido, String nombre, String observaciones);
}
