package com.example.hellsbells.db;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import com.example.hellsbells.beans.Pedido;
import com.example.hellsbells.beans.Producto;
import com.example.hellsbells.beans.TipoProducto;

public class AlmacenProductosDb extends SQLiteOpenHelper implements AlmacenDb{
	
	public AlmacenProductosDb(Context context) {
		super(context, "hellsbells", null, 11);
	}
		
	
	@Override 
	public void onCreate(SQLiteDatabase db) {	
//		db.execSQL("CREATE TABLE negocio ("+	
//				"neg_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
//				"nombre TEXT, pass TEXT, descripcion TEXT, direccion TEXT, cpostal TEXT, ciudad TEXT, pais TEXT, " +
//				"telefono TEXT, cif TEXT, latitud TEXT, longitud TEXT)");
		db.execSQL("CREATE TABLE tipoProducto ("+	
				"tp_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, descripcion TEXT)");
		db.execSQL("CREATE TABLE producto ("+	
				"pr_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, cantidad INTEGER, precio FLOAT NOT NULL, tipo INTEGER, "+				
				"FOREIGN KEY (tipo) REFERENCES tipoProducto (tp_id))");		
		db.execSQL("CREATE TABLE pedido ("+	
				"pd_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, precioTotal FLOAT NOT NULL, fecha TEXT, email INTEGER, " +
				"actualizar INTEGER DEFAULT 0, observaciones TEXT )" );
		db.execSQL("CREATE TABLE tipoProductoPedido ("+	
				"tpp_id INTEGER, "+	
				"nombre TEXT, descripcion TEXT," +
				"pedido INTEGER, "+
				"FOREIGN KEY (pedido) REFERENCES pedido (pd_id))");
		db.execSQL("CREATE TABLE productoPedido ("+	
				"prp_id INTEGER, "+	
				"nombre TEXT, cantidad INTEGER, precio FLOAT NOT NULL, tipo INTEGER, pedido INTEGER, "+
				"FOREIGN KEY (tipo) REFERENCES tipoProductoPedido (tpp_id), FOREIGN KEY (pedido) REFERENCES pedido (pd_id))");
		
		
	}
	
	
	
	@Override    
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		if (newVersion > oldVersion){
		db.execSQL("DROP TABLE IF EXISTS tipoProducto");
		db.execSQL("DROP TABLE IF EXISTS producto");
		db.execSQL("DROP TABLE IF EXISTS pedido");
		db.execSQL("DROP TABLE IF EXISTS tipoProductoPedido");
		db.execSQL("DROP TABLE IF EXISTS productoPedido");
		
//		db.execSQL("CREATE TABLE negocio ("+	
//				"neg_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
//				"nombre TEXT, pass TEXT, descripcion TEXT, direccion TEXT, cpostal TEXT, ciudad TEXT, pais TEXT, " +
//				"telefono TEXT, cif TEXT, latitud TEXT, longitud TEXT)");
		db.execSQL("CREATE TABLE tipoProducto ("+	
				"tp_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, descripcion TEXT)");
		db.execSQL("CREATE TABLE producto ("+	
				"pr_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, cantidad INTEGER, precio FLOAT NOT NULL, tipo INTEGER, "+				
				"FOREIGN KEY (tipo) REFERENCES tipoProducto (tp_id))");
		
		db.execSQL("CREATE TABLE pedido ("+	
				"pd_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
				"nombre TEXT, precioTotal FLOAT NOT NULL, fecha TEXT, email INTEGER, " +
				"actualizar INTEGER DEFAULT 0 , observaciones TEXT )" );
		
		db.execSQL("CREATE TABLE tipoProductoPedido ("+	
				"tpp_id INTEGER, "+	
				"nombre TEXT, descripcion TEXT," +
				"pedido INTEGER, "+
				"FOREIGN KEY (pedido) REFERENCES pedido (pd_id))");
		db.execSQL("CREATE TABLE productoPedido ("+	
				"prp_id INTEGER, "+	
				"nombre TEXT, cantidad INTEGER, precio FLOAT NOT NULL, tipo INTEGER, pedido INTEGER, "+
				"FOREIGN KEY (tipo) REFERENCES tipoProductoPedido (tpp_id), FOREIGN KEY (pedido) REFERENCES pedido (pd_id))");
		
		db.execSQL("INSERT INTO tipoProducto VALUES ( null, 'Ilumina', 'Productos ilumina')");
		db.execSQL("INSERT INTO tipoProducto VALUES ( null, 'Koleston', 'Productos kolestone')");
		db.execSQL("INSERT INTO tipoProducto VALUES ( null, 'Sebastian', 'Productos sebastian')");
		db.execSQL("INSERT INTO tipoProducto VALUES ( null, 'Comercial', 'Productos comercio')");
		db.execSQL("INSERT INTO tipoProducto VALUES ( null, 'Otros', 'Productos varios')");
		
		db.execSQL("INSERT INTO producto VALUES (null, '4/', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5/', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5/35', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5/7', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		db.execSQL("INSERT INTO producto VALUES (null, '6/', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		db.execSQL("INSERT INTO producto VALUES (null, '6/19', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '6/76', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7/', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7/31', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7/43', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7/7', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '8/', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '10/36', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '10/93', '0', '5,00', (select tp_id from tipoProducto where nombre='Ilumina'))");
		
		db.execSQL("INSERT INTO producto VALUES (null, '4.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5.55', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
		db.execSQL("INSERT INTO producto VALUES (null, '5.65', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '6.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7.4', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7.45', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7.7', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '7.71', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '8.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '88.43', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
//		db.execSQL("INSERT INTO producto VALUES (null, '12.0', '0', '5,00', (select tp_id from tipoProducto where nombre='Koleston'))");
		
		db.execSQL("INSERT INTO producto VALUES (null, 'Pack penetrait', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Champu volupt', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Acondicionador volupt', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Champu trillance', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Acondicionador trillance', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Champu hydre', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Tratamiento hydre', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Potiun 9 crema', '0', '5,00', (select tp_id from tipoProducto where nombre='Sebastian'))");
		
		db.execSQL("INSERT INTO producto VALUES (null, 'Deco', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Lacas', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Emulsion color touch', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Emulsion 4 vol touch', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Espumas', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Agua 20 vol', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Agua 30 vol', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Tintes nuevos pack', '0', '5,00', (select tp_id from tipoProducto where nombre='Otros'))");
		
		db.execSQL("INSERT INTO producto VALUES (null, 'Toallas', '0', '0', (select tp_id from tipoProducto where nombre='Comercial'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Muestras', '0', '0', (select tp_id from tipoProducto where nombre='Comercial'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Regalos', '0', '0', (select tp_id from tipoProducto where nombre='Comercial'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Bolsas venta', '0', '0', (select tp_id from tipoProducto where nombre='Comercial'))");
		db.execSQL("INSERT INTO producto VALUES (null, 'Catlogos', '0', '0', (select tp_id from tipoProducto where nombre='Comercial'))");
	
		
		}
	}
	
	@Override
	public void clean() {		
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("DELETE FROM pedido");
		db.execSQL("DELETE FROM tipoProductoPedido");
		db.execSQL("DELETE FROM productoPedido");
		db.close();
	}
	
	
	public String guardarTipoProducto(TipoProducto tipoProducto) {	
		
		SQLiteDatabase db = getWritableDatabase();
		Cursor cursor = db.rawQuery("SELECT nombre FROM tipoProducto" +
				" where upper(nombre)=upper('"+tipoProducto.getNombre()+"')", null);
		
		String ret = "OK";
		if(cursor.getCount()>0){
			cursor.close();
			ret = "DUPLICADO";
		}else{			
			db.execSQL("INSERT INTO tipoProducto VALUES ( null, '"+		
				tipoProducto.getNombre()+"', '"+tipoProducto.getDescripcion()+"')");		
			db.close();
		}
		return ret;
	
	}
	
	@Override
	public void guardarProducto(Producto producto) {
		SQLiteDatabase db = getWritableDatabase();		
		db.execSQL("INSERT INTO producto VALUES ( null, '"+		
				producto.getNombre()+"', '"+producto.getCantidadStock()+"','"+
				producto.getPrecio()+"', '"+producto.getIdTipoProducto()+"')");		
		db.close();
		
	}
	
	@Override
	public void updateProducto(String nombre, String cantidad, String precio, int id) {
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("UPDATE producto set nombre = '"+nombre+"' , cantidad = '"+cantidad+"' , precio = '"+precio+"' where pr_id = '"+id+"'");		
		db.close();
		
	}
	
	@Override
	public void updateProductosPedido(int idPedido, List<TipoProducto> contenido) {
		SQLiteDatabase db = getWritableDatabase();		
		
		try {
			db.beginTransaction();
			
			db.execSQL("UPDATE pedido set actualizar = '1' where pd_id = '"+idPedido+"'");
						
			for (TipoProducto tipoProducto : contenido) {
				for (Producto producto : tipoProducto.getProductos()) {
					int sum = producto.getCantidadStock()+producto.getCantidad();
					db.execSQL("UPDATE producto set cantidad = '"+sum+"' where pr_id = '"+producto.getId()+"'");
				}
			}
			
			db.setTransactionSuccessful();
			
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();			
		} finally{
			db.endTransaction();
			db.close();
		}
		
	}
	
	@Override
	public String guardarPedido(Pedido pedido, String opcion) {
		
//		db.execSQL("DELETE FROM pedido");
//		db.execSQL("DELETE FROM tipoProductoPedido");
//		db.execSQL("DELETE FROM productoPedido");
		String ret = "";
		if("consulta".equals(opcion)){
			//UPDATE
			ret = updatePedido(pedido);
    	}else{
    		//INSERT
    		ret = insertPedido(pedido);    		
    	}
		return ret;
	}
	
	public List<Producto> listaProductosPorTipo(int idTipo) {
		
		List<Producto> result = new ArrayList<Producto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		
		Cursor cursor = db.rawQuery("SELECT pr_id, nombre, pr_id, precio FROM producto" +
		" where tipo='"+idTipo+"' ORDER BY nombre", null);
		
		while (cursor.moveToNext()){		
			result.add(new Producto(cursor.getInt(0), cursor.getString(1), cursor.getInt(2), 0, cursor.getDouble(3),idTipo));		
		}
		
		cursor.close();		
		db.close();		
		return result;	
	}


	
	public List<TipoProducto> listaTipoProductos() {
	
		List<TipoProducto> result = new ArrayList<TipoProducto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		Cursor cursor = db.rawQuery("SELECT tp_id, nombre, descripcion FROM tipoProducto" +
		" ORDER BY nombre", null);
		
		while (cursor.moveToNext()){		
			result.add(new TipoProducto(cursor.getInt(0), cursor.getString(1), cursor.getString(2), null));		
		}
		
		for (TipoProducto tipoProducto : result) {
			List<Producto> prod = listaProductos(tipoProducto.getId());
			tipoProducto.setProductos(prod);
		}
		
		cursor.close();		
		db.close();		
		return result;	
	}


	@Override
	public void eliminarTipoProducto(int idTipoProducto) {
		SQLiteDatabase db = getWritableDatabase();
		
		
		try {
			db.beginTransaction();
						
			db.execSQL("DELETE FROM tipoProducto where tp_id="+idTipoProducto);
			db.execSQL("DELETE FROM producto where tipo="+idTipoProducto);

			db.setTransactionSuccessful();
			
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			
		} finally{
			db.endTransaction();
			db.close();
		}
	}
	
	@Override
	public void deleteProducto(int idProducto) {
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("DELETE FROM producto where pr_id="+idProducto);
		db.close();
	}
	
	@Override
	public void deletePedido(int idPedido) {
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("DELETE FROM pedido where pd_id="+idPedido);
		db.execSQL("DELETE FROM tipoProductoPedido where pedido="+idPedido);
		db.execSQL("DELETE FROM productoPedido where pedido="+idPedido);
		db.close();
	}
	
	


	
	@Override
	public List<Producto> listaProductos(int tipoProducto) {
		List<Producto> result = new ArrayList<Producto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		String[] param  = new String[1];
		param[0]= Integer.toString(tipoProducto);

		Cursor cursor = db.rawQuery("SELECT pr_id, nombre, cantidad, precio FROM producto" +
		" where tipo = ? ORDER BY nombre", param);
		
		while (cursor.moveToNext()){		
			result.add(new Producto(cursor.getInt(0), cursor.getString(1), cursor.getInt(2), 0, cursor.getDouble(3),tipoProducto));		
		}
		cursor.close();		
		db.close();		
		return result;	
	}
	
	@Override
	public List<Producto> listaProductosPedido(int tipoProducto, int pedido) {
		List<Producto> result = new ArrayList<Producto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		String[] param  = new String[2];
		param[0]= Integer.toString(tipoProducto);
		param[1]= Integer.toString(pedido);
		
		Cursor cursor = db.rawQuery("SELECT prp_id, nombre, cantidad, precio FROM productoPedido" +
		" where tipo = ? and pedido = ? ORDER BY nombre", param);
		
		while (cursor.moveToNext()){
			Cursor cursor1 = db.rawQuery("SELECT cantidad FROM producto where pr_id = "+cursor.getInt(0),null);					
			if(cursor1.getCount()>0){
				cursor1.moveToNext();	
				result.add(new Producto(cursor.getInt(0), cursor.getString(1), cursor1.getInt(0), cursor.getInt(2), cursor.getDouble(3),tipoProducto));
			}else{
				result.add(new Producto(cursor.getInt(0), cursor.getString(1), 0, cursor.getInt(2), cursor.getDouble(3),  tipoProducto));
			}
		}
		cursor.close();		
		db.close();		
		return result;	
	}


	public List<Producto> listaProductosPorTipoPedido(int idPedido, int idTipo) {
		
		List<Producto> result = new ArrayList<Producto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		Cursor cursor = db.rawQuery("SELECT prp_id, nombre, cantidad, precio FROM productoPedido" +
		" where pedido = '"+idPedido+"' and tipo ='"+idTipo+"' ORDER BY nombre", null);
		
		while (cursor.moveToNext()){		
			result.add(new Producto(cursor.getInt(0), cursor.getString(1), cursor.getInt(2), 0, cursor.getDouble(3), idTipo));			
		}
				
		cursor.close();		
		db.close();		
		return result;	
	}
	
	
	public List<TipoProducto> listaTipoProductosPedido(int idPedido) {
		
		List<TipoProducto> result = new ArrayList<TipoProducto>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		Cursor cursor = db.rawQuery("SELECT tpp_id, nombre, descripcion FROM tipoProductoPedido" +
		" where pedido = '"+idPedido+"' ORDER BY nombre", null);
		
		while (cursor.moveToNext()){		
			result.add(new TipoProducto(cursor.getInt(0), cursor.getString(1), cursor.getString(2), null));		
		}
		
		for (TipoProducto tipoProducto : result) {
			List<Producto> prod = listaProductosPedido(tipoProducto.getId(), idPedido);
			tipoProducto.setProductos(prod);
		}
		
		cursor.close();		
		db.close();		
		return result;	
	}
	
	@Override
	public List<Pedido> listaPedidos(String nombrePedido, String fechaPedido) {
		List<Pedido> result = new ArrayList<Pedido>();
		
		SQLiteDatabase db = getReadableDatabase();
		
		try {
			StringBuilder query = new StringBuilder
					("SELECT pd_id, nombre, fecha, precioTotal, email, actualizar, observaciones FROM pedido ");
			
			if(nombrePedido!=null && !nombrePedido.equals("") && (fechaPedido==null || fechaPedido.equals(""))){
				query.append("where nombre like '"+nombrePedido+"%'");
			}
			if(fechaPedido!=null && !fechaPedido.equals("") && (nombrePedido==null || nombrePedido.equals(""))){
				query.append("where fecha = '"+fechaPedido+"'");
			}
			if(fechaPedido!=null && !fechaPedido.equals("") && nombrePedido!=null && !nombrePedido.equals("")){
				query.append("where nombre like '"+nombrePedido+"%'");
				query.append("and fecha = '"+fechaPedido+"'");
			}
						
			Cursor cursor = db.rawQuery(query.toString(),null);
			if(cursor.getCount()==0){
				return result;
			}else if(cursor.getCount()>1){
				while (cursor.moveToNext()){
					int idPedido = cursor.getInt(0);
					Pedido p = new Pedido(cursor.getInt(0), cursor.getString(1), cursor.getString(2), 
								null, cursor.getInt(4),cursor.getString(6));
					p.setPrecioTotal(cursor.getDouble(3));
					p.setActualizar(cursor.getInt(5));
					
					List<TipoProducto> contenidoPedido = listaTipoProductosPedido(idPedido);
					p.setContenidoPedido(contenidoPedido);
					result.add(p);
				}
				cursor.close();
				return result;
			}else{
				
				cursor.moveToFirst();
				
				int idPedido = cursor.getInt(0);
				Pedido p = new Pedido(cursor.getInt(0), cursor.getString(1), cursor.getString(2), 
						null, cursor.getInt(4),cursor.getString(6));		
				p.setPrecioTotal(cursor.getDouble(3));
				p.setActualizar(cursor.getInt(5));
				
				List<TipoProducto> contenidoPedido = listaTipoProductosPedido(idPedido);
				p.setContenidoPedido(contenidoPedido);
				result.add(p);
				
				cursor.close();
			}
		} catch (Exception e) {
			db.close();	
			e.printStackTrace();
		}finally{
			db.close();	
		}
		
		db.close();		
		return result;	
	}
	
	
	@Override
	public Pedido getPedido(int idPedido) {
		
		Pedido result = null;		
		SQLiteDatabase db = getReadableDatabase();
		
		try {
			StringBuilder query = new StringBuilder("SELECT pd_id, nombre, fecha, precioTotal, email, actualizar, observaciones FROM pedido ");
			query.append("where pd_id = '"+idPedido+"'");
			
			Cursor cursor = db.rawQuery(query.toString(),null);
			if(cursor.getCount()==0){
				return result;
			}else if(cursor.getCount()>0){
				while (cursor.moveToNext()){					
					Pedido p = new Pedido(cursor.getInt(0), cursor.getString(1), cursor.getString(2), 
										  null, cursor.getInt(4),cursor.getString(6));
					p.setPrecioTotal(cursor.getDouble(3));
					p.setActualizar(cursor.getInt(5));
					
					List<TipoProducto> contenidoPedido = listaTipoProductosPedido(idPedido);
					p.setContenidoPedido(contenidoPedido);
					result = p;
				}
				cursor.close();				
			}
		} catch (Exception e) {
			db.close();	
			e.printStackTrace();
		}finally{
			db.close();	
		}
		
		db.close();		
		return result;	
	}

	
	
	@Override
	public List<String> getProductosMinimo(int minimoNotificacion) {
		
		List<String> resultado = new ArrayList<String>(); 
		
		SQLiteDatabase db = getReadableDatabase();
		
		String[] param  = new String[1];
		param[0]= Integer.toString(minimoNotificacion);		
		
		Cursor cursor = db.rawQuery("select t.nombre, p.nombre, p.cantidad from producto p, tipoProducto t where p.tipo =  t.tp_id" +
		" and p.cantidad < ? ORDER BY t.nombre, p.nombre", param);
		
		String oldTipo = "";
		while (cursor.moveToNext()){	
			String tipo = cursor.getString(0);
			String prod = cursor.getString(1);
			String cant = cursor.getInt(2)+"";
			if(!oldTipo.equals(tipo)){
				resultado.add(tipo.toUpperCase());				
			}
			oldTipo = tipo;
			resultado.add("     -     Producto: "+prod+";Cantidad actual stock: "+cant);
		}
		cursor.close();		
		db.close();		
		return resultado;	
	}
	
	
	private String insertPedido(Pedido pedido) {
		
		SQLiteDatabase db = getWritableDatabase();
		
		try {
			db.beginTransaction();
						
			//Insertamos pedido, sin precio total inicialmente
			ContentValues ins = new ContentValues();
			ins.put("nombre", pedido.getNombrePedido());
			ins.put("fecha", pedido.getFechaPedido());
			ins.put("precioTotal", 0);
			ins.put("email", 0);
			ins.put("observaciones", pedido.getObservaciones());
			
			Cursor cursor = db.rawQuery("SELECT nombre FROM pedido" +					
					" where upper(nombre)=upper('"+pedido.getNombrePedido()+"')", null);
			
			if(cursor.getCount()>0){
				cursor.close();
				return "DUPLICADO";
			}			
			
			int id_pedido = (int) db.insert("pedido", null, ins);
			guardadoTipoProd(pedido, db, id_pedido);

			db.setTransactionSuccessful();
			
			return id_pedido+"";
			
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			return "ERROR";
			
		} finally{
			db.endTransaction();
			db.close();
		}
	}


		
	private String updatePedido(Pedido pedido) {
		
		SQLiteDatabase db = getWritableDatabase();
	    String ret = "OK";	
		try {
			db.beginTransaction();
						
			Cursor cursor = db.rawQuery("SELECT pd_id, nombre FROM pedido" +
					" where nombre='"+pedido.getNombrePedido()+"'", null);
			
			int idPedido = -1;
			if(cursor.getCount()>0){
				cursor.moveToFirst();
				idPedido = cursor.getInt(0);
				
				db.execSQL("DELETE FROM tipoProductoPedido where pedido="+idPedido);
				db.execSQL("DELETE FROM productoPedido where pedido="+idPedido);
				db.execSQL("UPDATE pedido set observaciones='"+pedido.getObservaciones()+"' where pd_id = "+ idPedido);
				guardadoTipoProd(pedido, db, idPedido);
				
				cursor.close();
				
			}else{				
				cursor.close();
				ret = "NOTFOUND";
			}
			ret = idPedido+"";
			db.setTransactionSuccessful();
			
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			ret = "ERROR";
			
		} finally{
			db.endTransaction();
			db.close();			
		}
		return ret;
		
	}
	
	@Override
	public void setEmail(boolean b, int idPedido) {
		SQLiteDatabase db = getWritableDatabase();
		try {
			db.execSQL("UPDATE pedido set email=1 where pd_id = "+ idPedido);			
		} catch (SQLException e) {			
			db.close();
			e.printStackTrace();		
			
		} finally{			
			db.close();			
		}
	}
	

	
	private void guardadoTipoProd(Pedido pedido, SQLiteDatabase db, int id_pedido) {
		double precioPedidoTotal = 0;
		if(id_pedido>0){
			List<TipoProducto> contenido = pedido.getContenidoPedido();
			
			for (TipoProducto tipoProducto : contenido) {
				int id_tipo_producto = tipoProducto.getId();

				ContentValues insTipoProd = new ContentValues();
				insTipoProd.put("tpp_id", id_tipo_producto);
				insTipoProd.put("nombre", tipoProducto.getNombre());
				insTipoProd.put("descripcion", tipoProducto.getDescripcion());
				insTipoProd.put("pedido", id_pedido);
				
				db.insert("tipoProductoPedido", null, insTipoProd);				
				
				if(id_tipo_producto>0){
					List<Producto> productos = tipoProducto.getProductos();
					for (Producto producto : productos) {
						db.execSQL("INSERT INTO productoPedido VALUES ('"+producto.getId()+"', '"+		
								producto.getNombre()+"', '"+producto.getCantidad()+"','"+
								producto.getPrecio()+"', '"+id_tipo_producto+"', '"+id_pedido+"')");	
											
						precioPedidoTotal = precioPedidoTotal + (producto.getPrecio() * producto.getCantidad());
					}
				}
			}
		}
		//Actualizo precio total del pedido
		db.execSQL("UPDATE pedido set precioTotal="+precioPedidoTotal+" where pd_id = "+ id_pedido);
	}

	@Override
	public String[] getProductoToAdd(int idPedido, int tipoProducto) {
		List<Producto> prodPed = listaProductosPorTipoPedido(idPedido, tipoProducto);
		List<Producto> prod = listaProductosPorTipo(tipoProducto);
		
		List<String> tpp = new ArrayList<String>();
		for (Producto producto : prodPed) {
			tpp.add(producto.getNombre());
		}
		
		String resultado = "";
		for (Producto producto : prod) {
			if(!tpp.contains(producto.getNombre()))
				resultado += producto.getNombre()+";";
		}
		return resultado.split(";");
	}

	@Override
	public String[] getTipoProductoToAdd(int idPedido) {
		List<TipoProducto> tipoProdPed = listaTipoProductosPedido(idPedido);
		List<TipoProducto> tipoProd = listaTipoProductos();
		
		List<String> tpp = new ArrayList<String>();
		for (TipoProducto tipoProducto : tipoProdPed) {
			tpp.add(tipoProducto.getNombre());
		}
		
		String resultado = "";
		for (TipoProducto tipoProducto : tipoProd) {
			if(!tpp.contains(tipoProducto.getNombre()))
				resultado += tipoProducto.getNombre()+";";
		}
		return resultado.split(";");
	}
	
	
	
	@Override
	public void addProductoApedido(String prod, int idPedido, int idTipoProducto) {
		
		Producto producto = null;
		SQLiteDatabase db = getReadableDatabase();
		
		try {
			db.beginTransaction();
		
			Cursor cursor = db.rawQuery("SELECT pr_id, nombre, cantidad, precio FROM producto" +
			" where nombre = '"+prod+"' and tipo = '"+idTipoProducto+"'", null);
			
			while (cursor.moveToNext()){		
				producto = new Producto(cursor.getInt(0), cursor.getString(1), cursor.getInt(2), 0, cursor.getDouble(3), idTipoProducto);		
			}
			cursor.close();
			
			if(producto!=null){				
				db.execSQL("INSERT INTO productoPedido VALUES ('"+producto.getId()+"', '"+		
						producto.getNombre()+"', '"+producto.getCantidad()+"','"+
						producto.getPrecio()+"', '"+idTipoProducto+"', '"+idPedido+"')");
			}
			
			db.setTransactionSuccessful();
		
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			
		} finally{
			db.endTransaction();
			db.close();			
		}
			
		
	}


	@Override
	public void addTipoProductoApedido(String tp, int idPedido) {
		TipoProducto result = null;
		
		SQLiteDatabase db = getReadableDatabase();
		
		try {
			db.beginTransaction();
		
			Cursor cursor = db.rawQuery("SELECT tp_id, nombre, descripcion FROM tipoProducto" +
			" where nombre = '"+tp+"'", null);
			
			while (cursor.moveToNext()){		
				result = new TipoProducto(cursor.getInt(0), cursor.getString(1), cursor.getString(2), null);		
			}
			cursor.close();
			
			if(result!=null){
				
				List<Producto> listaProd = new ArrayList<Producto>();
				
				String[] param  = new String[1];
				param[0]= Integer.toString(result.getId());

				Cursor cursor1 = db.rawQuery("SELECT pr_id, nombre, cantidad, precio FROM producto" +
				" where tipo = ? ORDER BY nombre", param);
				
				while (cursor1.moveToNext()){		
					listaProd.add(new Producto(cursor1.getInt(0), cursor1.getString(1), cursor1.getInt(2), 0, cursor1.getDouble(3),result.getId()));		
				}
				cursor1.close();
				
				result.setProductos(listaProd);
				
				ContentValues insTipoProd = new ContentValues();
				insTipoProd.put("tpp_id", result.getId());
				insTipoProd.put("nombre", result.getNombre());
				insTipoProd.put("descripcion", result.getDescripcion());
				insTipoProd.put("pedido", idPedido);
				
				db.insert("tipoProductoPedido", null, insTipoProd);	
				
				for (Producto producto : listaProd) {
					db.execSQL("INSERT INTO productoPedido VALUES ('"+producto.getId()+"', '"+		
							producto.getNombre()+"', '"+producto.getCantidad()+"','"+
							producto.getPrecio()+"', '"+result.getId()+"', '"+idPedido+"')");
										
				}
				
			}
			
			db.setTransactionSuccessful();
		
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			
		} finally{
			db.endTransaction();
			db.close();			
		}
			
		
	}


	@Override
	public String copiarPedido(int idPedido, String nombre, String observaciones) {
		SQLiteDatabase db = getReadableDatabase();
		String ret = "";
		try {
			db.beginTransaction();
			
			String patron = "dd/MM/yyyy";
            SimpleDateFormat formato = new SimpleDateFormat(patron);            
            String fecha = formato.format(new Date());
              					
			Cursor cursor = db.rawQuery("SELECT nombre FROM pedido" +					
					" where upper(nombre)=upper('"+nombre+"')", null);
			
			if(cursor.getCount()>0){
				cursor.close();
				ret = "DUPLICADO";
			
			}else{
				cursor.close();
				//Insertamos pedido, sin precio total inicialmente
				ContentValues ins = new ContentValues();
				ins.put("nombre", nombre);
				ins.put("fecha", fecha);
				ins.put("observaciones", observaciones);
				ins.put("precioTotal", 0);
				ins.put("email", 0);
				
				int id_pedido = (int) db.insert("pedido", null, ins);
				
				Cursor cursor1 = db.rawQuery("SELECT tpp_id, nombre, descripcion FROM tipoProductoPedido" +
				" where pedido = '"+idPedido+"' ORDER BY nombre", null);
				
				List<TipoProducto> result = new ArrayList<TipoProducto>();
				
				while (cursor1.moveToNext()){		
					result.add(new TipoProducto(cursor1.getInt(0), cursor1.getString(1), cursor1.getString(2), null));		
				}
				cursor1.close();
				
				for (TipoProducto tipoProducto : result) {
					
					String[] param  = new String[2];
					param[0]= Integer.toString(tipoProducto.getId());
					param[1]= Integer.toString(idPedido);
					
					Cursor cursor2 = db.rawQuery("SELECT prp_id, nombre, cantidad, precio FROM productoPedido" +
					" where tipo = ? and pedido = ? ORDER BY nombre", param);
					
					List<Producto> result1 = new ArrayList<Producto>();
					
					while (cursor2.moveToNext()){
						Cursor cursor3 = db.rawQuery("SELECT cantidad FROM producto where pr_id = "+cursor2.getInt(0),null);
						cursor3.moveToNext();
						
						result1.add(new Producto(cursor2.getInt(0), cursor2.getString(1), cursor3.getInt(0), cursor2.getInt(2), cursor2.getDouble(3),tipoProducto.getId()));		
					}
					cursor.close();
					
					tipoProducto.setProductos(result1);
				}
				
				Pedido p = new Pedido(id_pedido,nombre, fecha, result, 0, observaciones);
				guardadoTipoProd(p, db, id_pedido);
	
				ret = id_pedido+"";
			}
			
			db.setTransactionSuccessful();
			
					
		} catch (SQLException e) {
			db.endTransaction();
			db.close();
			e.printStackTrace();
			
		} finally{
			db.endTransaction();
			db.close();			
		}
		return ret;
	}



}
